Public Member Functions | Private Member Functions | Static Private Member Functions | Private Attributes | Static Private Attributes

# TownDirectoryWindow Struct Reference

Town directory window class. More...

Inheritance diagram for TownDirectoryWindow:

## Public Member Functions
| TownDirectoryWindow (const WindowDesc *desc)
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnDropdownSelect (int widget, int index)
| A dropdown option associated to this window has been selected.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | OnHundredthTick ()
| Called once every 100 (game) ticks.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
## Private Member Functions
void | BuildSortTownList ()
## Static Private Member Functions
static int CDECL | TownNameSorter (const Town *const *a, const Town *const *b)
| Sort by town name.
static int CDECL | TownPopulationSorter (const Town *const *a, const Town *const *b)
| Sort by population (default descending, as big towns are of the most interest).
static int CDECL | TownRatingSorter (const Town *const *a, const Town *const *b)
| Sort by town rating.
## Private Attributes
GUITownList | towns
Scrollbar * | vscroll
## Static Private Attributes
static Listing | last_sorting = {false, 0}
static const Town * | last_town = NULL
static const StringID | sorter_names []
| Names of the sorting functions.
static GUITownList::SortFunction *const | sorter_funcs []
| Available town directory sorting functions.

## Detailed Description

Town directory window class.

Definition at line 628 of file town_gui.cpp.

## Member Function Documentation

virtual void TownDirectoryWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 741 of file town_gui.cpp.

References _current_text_dir, _local_company, Town::cache, Window::DrawSortButtonState(), DrawSprite(), DrawString(), FONT_HEIGHT_NORMAL, Scrollbar::GetCapacity(), Scrollbar::GetPosition(), GetSpriteSize(), HasBit(), Town::have_ratings, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, INVALID_TILE, GUIList< T, F >::IsDescSortOrder(), SmallVector< T, S >::Length(), TownCache::population, Town::ratings, Window::resize, SBS_DOWN, SetDParam(), ResizeInfo::step_height, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, WID_TD_LIST, WID_TD_SORT_ORDER, and Town::xy.

virtual void TownDirectoryWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 841 of file town_gui.cpp.

References _ctrl_pressed, GUIList< T, F >::ForceResort(), GUIList< T, F >::GetListing(), Scrollbar::GetScrolledRowFromWidget(), SmallVector< T, S >::Length(), Listing::order, ScrollMainWindowToTile(), Window::SetDirty(), GUIList< T, F >::SetListing(), ShowDropDownMenu(), ShowExtraViewPortWindow(), GUIList< T, F >::Sort(), sorter_names, GUIList< T, F >::SortType(), GUIList< T, F >::ToggleSortOrder(), WD_FRAMERECT_TOP, WID_TD_LIST, WID_TD_SORT_CRITERIA, WID_TD_SORT_ORDER, and Town::xy.

virtual void TownDirectoryWindow::OnDropdownSelect | ( | int | widget,
|  | int | index |
| ) |  |  | `[inline, virtual]`

A dropdown option associated to this window has been selected.

Parameters:

  | widget | the widget (button) that the dropdown is associated with.
  | index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 878 of file town_gui.cpp.

References GUIList< T, F >::GetListing(), GUIList< T, F >::SetSortType(), GUIList< T, F >::SortType(), and WID_TD_SORT_CRITERIA.

virtual void TownDirectoryWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 911 of file town_gui.cpp.

References GUIList< T, F >::ForceRebuild(), and GUIList< T, F >::ForceResort().

virtual void TownDirectoryWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 889 of file town_gui.cpp.

References Window::DrawWidgets(), and GUIList< T, F >::NeedRebuild().

virtual void TownDirectoryWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 901 of file town_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), and WID_TD_LIST.

virtual void TownDirectoryWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 728 of file town_gui.cpp.

References GetWorldPopulation(), SetDParam(), sorter_names, GUIList< T, F >::SortType(), WID_TD_SORT_CRITERIA, and WID_TD_WORLD_POPULATION.

static int CDECL TownDirectoryWindow::TownPopulationSorter | ( | const Town *const * | a,
|  | const Town *const * | b |
| ) |  |  | `[inline, static, private]`

Sort by population (default descending, as big towns are of the most interest).

Definition at line 686 of file town_gui.cpp.

References TownNameSorter().

virtual void TownDirectoryWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 789 of file town_gui.cpp.

References GetSpriteSize(), GetStringBoundingBox(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, INVALID_STRING_ID, SmallVector< T, S >::Length(), max(), maxdim(), SetDParam(), SetDParamMaxDigits(), sorter_names, WD_FRAMERECT_LEFT, WD_FRAMERECT_TOP, WD_SORTBUTTON_ARROW_WIDTH, WID_TD_LIST, WID_TD_SORT_CRITERIA, WID_TD_SORT_ORDER, and WID_TD_WORLD_POPULATION.

## Field Documentation

GUITownList::SortFunction *const TownDirectoryWindow::sorter_funcs`[static, private]`

Initial value:

     {
      &TownNameSorter,
      &TownPopulationSorter,
      &TownRatingSorter,
    }

Available town directory sorting functions.

Definition at line 636 of file town_gui.cpp.

const StringID TownDirectoryWindow::sorter_names`[static, private]`

Initial value:

     {
      STR_SORT_BY_NAME,
      STR_SORT_BY_POPULATION,
      STR_SORT_BY_RATING,
      INVALID_STRING_ID
    }

Names of the sorting functions.

Definition at line 635 of file town_gui.cpp.

Referenced by OnClick(), SetStringParameters(), and UpdateWidgetSize().

The documentation for this struct was generated from the following file:

- src/town_gui.cpp